package gui.dialogs;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class FileNewDialog extends JOptionPane implements ActionListener
{
	Component parent;

	JPanel panelSimFile = new JPanel();
	JTextField textSimFile = new JTextField(new String(""));
	JButton bSimFile = new JButton("...");

	JPanel panelCellProgramFile = new JPanel();
	JTextField textCellProgramFile = new JTextField(new String(""));
	JButton bCellProgramFile = new JButton("...");

	JPanel panelOutputFile = new JPanel();
	JTextField textOutputFile = new JTextField(new String(""));
	JButton bOutputFile = new JButton("...");

	JPanel panelStatisticsFile = new JPanel();
	JTextField textStatisticsFile = new JTextField(new String(""));
	JButton bStatisticsFile = new JButton("...");

	JPanel panelErrorFile = new JPanel();
	JTextField textErrorFile = new JTextField(new String(""));
	JButton bErrorFile = new JButton("...");

	public FileNewDialog(Component p_parent)
	{
		parent = p_parent;

		JLabel labelSimFile = new JLabel(new String("Simulation File"));
		panelSimFile.setLayout(new BorderLayout());
		panelSimFile.add(labelSimFile, BorderLayout.NORTH);
		panelSimFile.add(textSimFile, BorderLayout.CENTER);
		panelSimFile.add(bSimFile, BorderLayout.EAST);

		JLabel labelCellProgramFile = new JLabel(new String("Cell Program File"));
		panelCellProgramFile.setLayout(new BorderLayout());
		panelCellProgramFile.add(labelCellProgramFile, BorderLayout.NORTH);
		panelCellProgramFile.add(textCellProgramFile, BorderLayout.CENTER);
		panelCellProgramFile.add(bCellProgramFile, BorderLayout.EAST);

		JLabel labelOutputFile = new JLabel(new String("Output File"));
		panelOutputFile.setLayout(new BorderLayout());
		panelOutputFile.add(labelOutputFile, BorderLayout.NORTH);
		panelOutputFile.add(textOutputFile, BorderLayout.CENTER);
		panelOutputFile.add(bOutputFile, BorderLayout.EAST);

		JLabel labelStatisticsFile = new JLabel(new String("Statistics File"));
		panelStatisticsFile.setLayout(new BorderLayout());
		panelStatisticsFile.add(labelStatisticsFile, BorderLayout.NORTH);
		panelStatisticsFile.add(textStatisticsFile, BorderLayout.CENTER);
		panelStatisticsFile.add(bStatisticsFile, BorderLayout.EAST);

		JLabel labelErrorFile = new JLabel(new String("Error File"));
		panelErrorFile.setLayout(new BorderLayout());
		panelErrorFile.add(labelErrorFile, BorderLayout.NORTH);
		panelErrorFile.add(textErrorFile, BorderLayout.CENTER);
		panelErrorFile.add(bErrorFile, BorderLayout.EAST);

		bSimFile.addActionListener(this);
		bCellProgramFile.addActionListener(this);
		bOutputFile.addActionListener(this);
		bStatisticsFile.addActionListener(this);
		bErrorFile.addActionListener(this);
	}

	public Vector getFileNames(Vector args)
	{
		int retVal;

		if(args != null)
		{
			textSimFile.setText((String)args.elementAt(0));
			textCellProgramFile.setText((String)args.elementAt(1));
			textOutputFile.setText((String)args.elementAt(2));
			textStatisticsFile.setText((String)args.elementAt(3));
			textErrorFile.setText((String)args.elementAt(4));
		}

		Object controls[] = new Object[] { panelSimFile, panelCellProgramFile,
											panelOutputFile, panelStatisticsFile, panelErrorFile };
		retVal = showConfirmDialog(parent, controls, "New Simulation", JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
		if(retVal == JOptionPane.OK_OPTION)
		{
			Vector retVec = new Vector();

			retVec.add(new String(textSimFile.getText()));
			retVec.add(new String(textCellProgramFile.getText()));
			retVec.add(new String(textOutputFile.getText()));
			retVec.add(new String(textStatisticsFile.getText()));
			retVec.add(new String(textErrorFile.getText()));

			return retVec;
		}
		else
		{
			return null;
		}
	}

	public void actionPerformed(ActionEvent e)
	{
		JFileChooser chooser = new JFileChooser();
		int status = chooser.showOpenDialog(parent);
		String fileName;

		if(status == JFileChooser.APPROVE_OPTION)
		{
			File f = chooser.getSelectedFile();
			fileName = f.getPath();
		}
		else
		{
			return;
		}

		if(e.getSource() == (JButton)bSimFile)
		{
			textSimFile.setText(fileName);
		}
		else if(e.getSource() == (JButton)bCellProgramFile)
		{
			textCellProgramFile.setText(fileName);
		}
		else if(e.getSource() == (JButton)bOutputFile)
		{
			textOutputFile.setText(fileName);
		}
		else if(e.getSource() == (JButton)bStatisticsFile)
		{
			textStatisticsFile.setText(fileName);
		}
		else if(e.getSource() == (JButton)bErrorFile)
		{
			textErrorFile.setText(fileName);
		}
	}
}
