package simulator;

import util.Assert;
import java.util.Vector;

public class SimulationParameters {
    private Vector cpaFiles; // vector of String's
    private String simFile;
    private String errFile;
    private String statsFile;
    private String outFile;
    private boolean batchMode;
    private int maxSteps;

    public SimulationParameters () {
	cpaFiles = new Vector ();
    }

    public void setSimFile (String sim) { 
	Assert.check (simFile == null);
	simFile = sim;
    }

    public void setErrFile (String err) { 
	Assert.check (errFile == null);
	errFile = err;
    }

    public void setOutFile (String out) { 
	Assert.check (outFile == null);
	outFile = out;
    }

    public void setStatsFile (String stats) { 
	Assert.check (statsFile == null);
	statsFile = stats;
    }

    public void setBatchMode (boolean mode) {
	batchMode = mode;
    }

    public void setMaxSteps (int steps) {
	maxSteps = steps;
    }

    public void addProgramFile (String cpa) {
	cpaFiles.add (cpa);
    }

    public boolean parametersDefined () {
	return simFile != null;
    }

    public String getSimFile () { return simFile; }
    public String getOutFile () { return outFile; }
    public String getErrFile () { return errFile; }
    public String getStatsFile () { return statsFile; }
    public Vector getCellPrograms () { return cpaFiles; }
}
