package util;

import java.util.*;

public class ChemicalCondition2
{
	private String chemical;
	private float bound;
	private int boundType;
	private String chemical2;
	private String direction;

	public ChemicalCondition2 (String p_chem, int p_boundType, float p_bound, String p_direction)
	{
		chemical = p_chem;
		bound = p_bound;
		boundType = p_boundType;
		direction = p_direction;
	}

	public ChemicalCondition2 (String p_chem, int p_boundType, String p_chem2, String p_direction)
	{
		chemical = p_chem;
		boundType = p_boundType;
		chemical2 = p_chem2;
		direction = p_direction;
	}

	public ChemicalCondition2(ChemicalCondition2 cc)
	{
		chemical = cc.getChemical();
		boundType = cc.getBoundType();
		if(boundType == 0)
		{
			chemical2 = cc.getChemical2();
		}
		else
		{
			bound = cc.getBound();
		}
		direction = cc.getDirection();
	}

	public String getChemical() { return new String(chemical); }

	public String getChemical2() { return new String(chemical2); }

	public float getBound() { return bound; }

	public int getBoundType() { return boundType; }
	
	public String getDirection() { return direction; }

	public void setChemical(String p_chem) { chemical = p_chem; }

	public void setChemical2(String p_chem2) { chemical = p_chem2; }

	public void setBound(float p_lb) { bound = p_lb; }

	public void setBoundType(int p_ub) { boundType = p_ub;	}

	public void setDirection(String p_dir) { direction = p_dir; }

	public String toString ()
	{
		if(direction != null)
		{
			if(boundType == 2)
				return "(" + chemical + " < " + chemical2 + ")" + " from " + direction + " direction";
			else if(boundType == 1)
				return "(" + chemical + " < " + bound + ")" + " from " + direction + " direction";
			else if(boundType == -1)
				return "(" + chemical + " > " + bound + ")" + " from " + direction + " direction";
			else if(boundType == 0)
				return "(" + chemical + " = " + bound + ")" + " from " + direction + " direction";
		}
		else
		{
			if(boundType == 2)
				return "(" + chemical + " < " + chemical2 + ")";
			else if(boundType == 1)
				return "(" + chemical + " < " + bound + ")";
			else if(boundType == -1)
				return "(" + chemical + " > " + bound + ")";
			else if(boundType == 0)
				return "(" + chemical + " = " + bound + ")";
		}
		return "";
	}
}
